/*
 * Environment.h
 *
 *  Created on: Oct 26, 2013
 *      Author: nghiaht
 */

#ifndef ENVIRONMENT_H_
#define ENVIRONMENT_H_

#include "IsoGaussian.h"
#include "GP.h"

class Environment
{
	private:

	IsoGaussian* covfunc; // covariance function
	Mat Field, K; // the entire field and its covariance matrix
	int N, nR; // the size of the field and the number of realizations generated from the underlying GP model

	Vec mean; // the mean function
	Mat Y; // the set of realizations generated

	public:

	Environment(IsoGaussian* covfunc, Mat &Field, int N, int m);

	double Observe(int idx, int version);

	double RMS(Vec &ID, int v, vector <IsoGaussian*> &kernels, Vec &b);

};

#endif /* ENVIRONMENT_H_ */
