/*
 * ITELearner.h
 *
 *  Created on: Jan 14, 2014
 *      Author: nghiaht
 */

#ifndef ITELEARNER_H_
#define ITELEARNER_H_

#include "IsoGaussian.h"

#define N_SAMPLE 5
#define THRESHOLD 0.01

class ITELearner
{
	private:

	Mat Field; // the entire field
	int N, nL; // the size of the field and the number of candidate kernels
	bool *marker; // marker of whether a location has been selected previously
	Vec b; // the current distribution over candidate kernels

	Vec X, Y; // X: the set of indices of selected locations; Y: the corresponding measurements
	int m; // the number of selected locations so far

	Vec hmap;

	vector <IsoGaussian*> covfunc; // the set of candidate kernels
	vector <Mat> K, L; // corresponding covariance matrices and their Cholesky decompositions

	int left, right; // the current (index) range of bandwidth
	Vec htest;

	Vec AprioriDesign(int n, int kernel);
	int GreedyChoice(int kernel);
	double Entropy(int s, int kernel);

	public:

	ITELearner(Mat &Field, int N, vector <IsoGaussian*> &covfunc , int nL, Vec &b);

	Vec Move(int n);
	void Update(Vec selected, Vec obs);

};

#endif /* ITELEARNER_H_ */
